- LeetCode_两数之和 ===
给定一个整数数组nums和一个整数目标值target,请你在该数组中找出和为目标值target的那两个整数,并返回它们的数组下标。
你可以假设每种输入只会对应一个答案。但是,数组中同一个元素在答案里不能重复出现。
你可以按任意顺序返回答案。
示例 1
输入:nums = [2,7,11,15], target = 9 输出:[0,1] 解释:因为 nums[0] + nums[1] == 9 ,返回 [0, 1] 。
示例 2:
输入:nums = [3,2,4], target = 6 输出:[1,2]
示例 3:
输入:nums = [3,3], target = 6 输出:[0,1]
提示:
只会存在一个有效答案
进阶:你可以想出一个时间复杂度小于 O(n2) 的算法吗?
方法一:暴力枚举
最简单的方法就是对数组中的每一个数x,都去遍历找后面是否存在target - x的值是否存在。
class Solution {
public int[] twoSum(int[] nums, int target) {
int size = nums.length;
for (int i = 0; i < size; i++) {
for (int j = i + 1; j < size; j++) {
if (nums[i] + nums[j] == target) {
return new int[]{i, j};
}
}
}
return new int[0];
}
}
#include <vector>
using namespace std;
class Solution {
public:
vector<int> twoSum(vector<int> &nums, int target) {
int size = nums.size();
for (int i = 0; i < size; i++) {
for (int j = i + 1; j < size; j++) {
if (nums[i] + nums[j] == target) {
return {i, j};
}
}
}
return {};
}
};
复杂度分析:
-
时间复杂度:O(N²),其中N是数组中的元素数量。最坏情况下数组中任意两个数都要被匹配一次。
-
空间复杂度:O(1)。
方法二: 哈希表
注意到方法一的时间复杂度较高的原因是寻找target - x的时间复杂度过高。
因此,我们需要一种更优秀的方法,能够快速寻找数组中是否存在目标元素。如果存在,我们需要找出它的索引。
使用哈希表,可以将寻找target - x的时间复杂度降低到从O(N)降低到O(1)。
如果想要快速确定某个元素是否在nums数组中,并且可以快速的获取所在下表index。 我们的第一反应就是将数组维护成一个Map结构:
- key: 存储数组里的值
- value: 存储数组的下标index
这样我们只需要通过target - nums[i]的值去Map中查找即可。
但是这样存在一个问题,就是你需要先把数组中的值都放到Map中,需要多一步循环。
其实我们可以先创建一个Map,在Map的初始化过程中什么元素都不放。
对于每一个x,我们首先查询哈希表中是否存在target-x,如果已存在就返回,如果不存在那再将x插入到哈希表中,即可保证不会让x和自己匹配。
这样只需要一次循环就可以了,而且Map数组不用提前初始化,在性能和内存占用率都比较低。
class Solution {
public int[] twoSum(int[] nums, int target) {
Map<Integer, Integer> hashtable = new HashMap<Integer, Integer>();
for (int i = 0; i < nums.length; ++i) {
if (hashtable.containsKey(target - nums[i])) {
return new int[]{hashtable.get(target - nums[i]), i};
}
hashtable.put(nums[i], i);
}
return new int[0];
}
}
#include <unordered_map>
#include <vector>
using namespace std;
class Solution {
public:
vector<int> twoSum(vector<int> &nums, int target) {
unordered_map<int, int> map;
for (int i = 0; i < nums.size(); i ++) {
auto it = map.find(target - nums[i]);
if (it != map.end()) {
return {i, it->second};
}
map[nums[i]] = i;
}
return {};
}
};
复杂度分析:
-
时间复杂度:O(N),其中 N 是数组中的元素数量。对于每一个元素 x,我们可以 O(1) 地寻找 target - x。
-
空间复杂度:O(N),其中 N 是数组中的元素数量。主要为哈希表的开销。
- 邮箱 :charon.chui@gmail.com
- Good Luck!